﻿using Syncfusion.Windows.PropertyGrid;
using Syncfusion.Windows.Shared;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace RadioButtonPGSample
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.Loaded += new RoutedEventHandler(MainWindow_Loaded);
            this.pgrid.SelectedObject = new Customer();
        }

        private void MainWindow_Loaded(object sender, RoutedEventArgs e)
        {
            CustomEditor RadioEditor = new CustomEditor() { HasPropertyType = true, PropertyType = typeof(bool) };
            RadioEditor.Editor = new RadioButtonPGSample.ICustomTypeEditors.RadiobuttonEditor();
            pgrid.CustomEditorCollection.Add(RadioEditor);
            pgrid.RefreshPropertygrid();
        }
    }
    public class Customer
    {
        private string _name;
        private int _age;
        private bool _maritalstatus;
        private string _address;
        private string _email;
        

        public string Name
        {
            get
            {
                return _name;
            }
            set
            {
                _name = value;
            }
        }

        public bool MaritalStatus
        {
            get
            {
                return _maritalstatus;
            }
            set
            {
                _maritalstatus = value;
            }
        }

        public string Address
        {
            get
            {
                return _address;
            }
            set
            {
                _address = value;
            }
        }

        public int Age
        {
            get
            {
                return _age;
            }
            set
            {
                _age = value;
            }
        }

        public string Email
        {
            get
            {
                return _email;
            }
            set
            {
                _email = value;
            }
        }
    }
    public class ICustomTypeEditors
    {
        public class RadiobuttonEditor : ITypeEditor
        {
            public void Attach(PropertyViewItem property, PropertyItem info)
            {
            }

            StackPanel sp;
            RadioButton radioButton;
            RadioButton radioButton1;
            public object Create(PropertyInfo propertyInfo)
            {
                radioButton = new RadioButton()
                {
                    Content = "Married",
                    IsChecked = false,
                    GroupName = "grp"
                };
         
                radioButton1 = new RadioButton()
                {
                    Content = "Single",
                    IsChecked = true,
                    GroupName = "grp"
                };
                sp = new StackPanel();
                sp.Orientation = Orientation.Horizontal;
                sp.Children.Add(radioButton);
                sp.Children.Add(radioButton1);
                return sp;
            }

            public void Detach(PropertyViewItem property)
            {
                throw new NotImplementedException();
            }
        }
    }
}
